import Toybox.Graphics;
import Toybox.Lang;
import Toybox.System;
import Toybox.WatchUi;

class Onoff extends WatchUi.View
{

private var id;

function initialize(id)
{

    //L.dbg_log(L.DBG_LIFE, "Onoff.initialize()");
    View.initialize();

    me.id = id;
}

// Load your resources here
function onLayout(dc as Dc) as Void
{

    //L.dbg_log(L.DBG_LIFE, "Onoff.onLayout()");
}

// Called when this View is brought to the foreground. Restore
// the state of this View and prepare it to be shown. This includes
// loading resources into memory.
function onShow() as Void
{

    //L.dbg_log(L.DBG_LIFE, "Onoff.onShow()");
}

// Update the view
function onUpdate(dc as Dc) as Void
{

    //L.dbg_log(L.DBG_LIFE, "Onoff.onUpdate()");

    var dev = C.outlets[id];
    var bitm = WatchUi.loadResource(C.get_icon(dev["icon"], dev["state"], C.radius));
    var off = bitm.getWidth()/2;
    var bm_xy = C.radius - off;
    var txt_y = bm_xy - dc.getFontHeight(Graphics.FONT_MEDIUM);

    dc.setColor(C.WHITE, C.BLACK);
    dc.clear();

    dc.drawText(C.cx, txt_y, Graphics.FONT_MEDIUM, dev["name"], Graphics.TEXT_JUSTIFY_CENTER);
    dc.drawBitmap(bm_xy, bm_xy, bitm);

    txt_y = C.radius + off;
    var info = dev["info"] as Dictionary;
    dc.drawText(C.cx, txt_y, Graphics.FONT_TINY, info["type"], Graphics.TEXT_JUSTIFY_CENTER);
}

// Called when this View is removed from the screen. Save the
// state of this View here. This includes freeing resources from
// memory.
function onHide() as Void
{

    //L.dbg_log(L.DBG_LIFE, "Onoff.onHide():" + id);
}

}
class OnoffDelegate extends WatchUi.BehaviorDelegate
{

private var id;

function initialize(id)
{

    //L.dbg_log(L.DBG_LIFE, "OnoffDelegate.initialize()");
    BehaviorDelegate.initialize();

    me.id = id;
}

function onNextPage() as Boolean
{

    //L.dbg_log(L.DBG_LIFE, "OnoffDelegate.onNextPage()");
    return true;
}

function onPreviousPage() as Boolean
{

    //L.dbg_log(L.DBG_LIFE, "OnoffDelegate.onPreviousPage()");
    return true;
}

function onMenu() as Boolean
{

    //L.dbg_log(L.DBG_LIFE, "OnoffDelegate.onMenu()");
    return true;
}

function onSelect() as Boolean
{

    //L.dbg_log(L.DBG_LIFE, "OnoffDelegate.onSelect():" + id);

    var dev = C.outlets[id];
    var state = dev["state"];
    if (state == C.STATE_ON) {
        state = C.STATE_OFF; }
    else {
        state = C.STATE_ON; }
    var set = dev["ctrl"];
L.log(dev["name"] + ":" + dev["state"] + " => " + state);
    dev["state"] = state;
    set.invoke(C.CTRL_SET, dev, state, method(:new_state));

    return true;
}

public function new_state(res)
{

    WatchUi.requestUpdate();
}

}
