//
// Copyright 2015-2021 by Garmin Ltd. or its subsidiaries.
// Subject to Garmin SDK License Agreement and Wearables
// Application Developer Agreement.
//

import Toybox.Communications;
import Toybox.Cryptography;
import Toybox.Lang;
import Toybox.Time.Gregorian;

class ScanDevs
{

var done;

var current;
var max;

public function initialize(done)
{

    me.done = done;

    max = C.outlets.size();

    current = -1;
    scan_next();
}

public function scan_next()
{

    current += 1;
    if (current >= max) {
        done.invoke(true);
        return;
    }
    var outlet = C.outlets[current];
    var ctrl = outlet["ctrl"];
//C.log("scan_next:" + current + " = " + outlet["name"]);
    var msg = "";
    switch (outlet["type"]) {

    case C.OUTLET_TPLINK:
        msg = "TpLink";
        break;

    case C.OUTLET_WEMO:
        msg = "Wemo";
        break;

    case C.OUTLET_ATHOME:
        msg = "AtHome";
        break;

    default:
        msg = "Found";
        break;

    }
    C.set_alert(msg + "\n" + outlet["name"]);
    ctrl.invoke(C.CTRL_SCAN, outlet, null, method(:scan_action));
}

public function scan_action(res)
{

//L.dbg_log(L.DBG_BASIC, "scan_action:" + C.outlets[current]["name"] + " => " + C.state2str(res) + "(" + res + ")");
    C.outlets[current]["state"] = res;
    scan_next();
}

}
